package nl.amis.calculator;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import oracle.jbo.domain.Number;

public class Calculator extends HashMap {

    private static final String reset ="RESET";
    private static final String add ="ADD";
    private static final String substract ="SUBSTRACT";
    private static final String divide ="DIVIDE";
    private static final String multiply ="MULTIPLY";
    private static final String round ="ROUND";
    private static final String mod ="MOD";
    private static final String aslong ="LONG";
    private static final String asinteger ="INTEGER";
    private static final String equals ="EQUALS";
    
    public List operands = new ArrayList();
    
    public Calculator() {
    }

    public Object get(Object key) {
        boolean processed = false;
        if (key instanceof String) {
            String command = (String)key;
            if (reset.equalsIgnoreCase(command)) {
                operands = new ArrayList();
                return this;
            }
            if (equals.equalsIgnoreCase(command)) {
                processed=true;            
                return operands.get(operands.size()-1);
            }
            Object result = null;
            if (add.equalsIgnoreCase(command)) {
                result = add( operands.get(operands.size()-2), operands.get(operands.size()-1));
                processed=true;
            }
            if (substract.equalsIgnoreCase(command)) {
                result = substract( operands.get(operands.size()-2), operands.get(operands.size()-1));
                processed=true;
            }
            if (multiply.equalsIgnoreCase(command)) {
                result = multiply( operands.get(operands.size()-2), operands.get(operands.size()-1));
                processed=true;
            }
            if (divide.equalsIgnoreCase(command)) {
                result = divide( operands.get(operands.size()-2), operands.get(operands.size()-1));
                processed=true;
            }
            if (mod.equalsIgnoreCase(command)) {
                result = mod( operands.get(operands.size()-2), operands.get(operands.size()-1));
                processed=true;
            }
            if (aslong.equalsIgnoreCase(command)) {
                result = aslong(  operands.get(operands.size()-1));
                operands.add(null); // since this is a one operand operation
                processed=true;
            }
            if (asinteger.equalsIgnoreCase(command)) {
                result = asinteger(  operands.get(operands.size()-1));
                operands.add(null); // since this is a one operand operation
                processed=true;
            }
            if (round.equalsIgnoreCase(command)) {
                result = round( operands.get(operands.size()-1));
                operands.add(null); // since this is a one operand operation
                processed=true;
            }
            if (result!=null) {
                operands.remove(operands.size()-1);
                operands.remove(operands.size()-1);
                operands.add(result);                            
            }                       
        }
        if (!processed)
          operands.add(key);    
      return this;
    }
    
    private Object add(Object o1, Object o2) {
        return makeNumber(o1).add(makeNumber(o2));        
    }
    private Object substract(Object o1, Object o2) {
        return makeNumber(o1).subtract(makeNumber(o2));        
    }
    private Object multiply(Object o1, Object o2) {
        return makeNumber(o1).multiply(makeNumber(o2));        
    }
    private Object divide(Object o1, Object o2) {
        try {
            return makeNumber(o1).divide(makeNumber(o2));        
        }
        catch (Exception e) {
            return null;
        }
    }
    private Object mod(Object o1, Object o2) {
        try {
            return makeNumber(o1).mod(makeNumber(o2));        
        }
        catch (Exception e) {
            return null;
        }
    }
    private Object round(Object o1) {
        try {
            return makeNumber(o1).round(0);        
        }
        catch (Exception e) {
            return null;
        }
    }
    private Object aslong(Object o1) {
        try {
            return new Long(makeNumber(o1).longValue());        
        }
        catch (Exception e) {
            return null;
        }
    }
    
    private Object asinteger(Object o1) {
        try {
            return new Integer(makeNumber(o1).intValue());        
        }
        catch (Exception e) {
            return null;
        }
    }
    
    private Number makeNumber(Object o) {
       try {
       if (o instanceof Number) return (Number)o;
           if (o instanceof String) return new Number((String)o);
           if (o instanceof Long) return new Number((Long)o);
           if (o instanceof Integer) return new Number((Integer)o);
           if (o instanceof Double) return new Number((Double)o);
       } catch (Exception e) {
           return null;
       }
       return null;
    }

}
